/*Written by Pop AKA Konstantin E. Borisov */
#include<dos.h>
#include<math.h>
#include<conio.h>
#include<stdio.h>
#include<alloc.h>
#include<fcntl.h>
#include<stdlib.h>
#include<io.h>
#include<time.h>
#include<process.h>

void prod(float *X, float * A);
void draw (void);
void n_mat( void  );
void axis( float *Z );
void mltp( float *Y, float *Z, float *X);
float lnt( float *X );
void grayscale(void);
void set_col(char col, char r, char g, char b);
void reset_vid(void);
void set_vid(unsigned short int v);
void scan_vid(void);
void triangle(int x1, int y1, int x2, int y2, int x3, int y3, char col);
void cls(void);
void read_obj(void);
void qsrt(int *a, int ilo, int ihi );
void create_norm(void);
/*
	Object structure:
								Number  of vertexes 	(2 bytes)
							 Vertex1 	X, Y, Z 		(2 bytes * 3)
							 ------------------------------
										Number of facets 		(2 bytes)
										Facet1 A, B, C 		(2 bytes * 3)
								A, B, C - Vertex numbers in the list of vetrtexes
	*/

	/*
		 न ᯮ ᫥騬 ࠧ:
		Ox -  ᫥ ࠢ,
		Oy -  ᭨ ,
		Oz -   ࠭.
		 ⥫ ࠢ   Oz.
	*/


/* matrix[] -  室    */

float matrix[9]={  0.9961946,  0.0871557, 		  0,	/* न   */
									-0.0871557,	 0.9961946,   		0, /*  ஬ (  5 .)*/
													 0,	  			 0,	  		1,
					};
float matrix0[9]={  0.9961946,  0.0871557, 		  0,	/*  ࢮ砫쭮  */
									-0.0871557,	 0.9961946,   		0,
													 0,	  			 0,	  		1,
					};

int *p_z, *iz;

float off;

float c[9], mc[9];	/* Matrixes */
float *p;						/* Pointer to 3d object */
float *nrm;				/* ⥫  ଠ  ࠭ */

int num, num_f;			/* Number of vertexes and facets */
char far *vb, *rb; /* Virtual and real video buffers */
unsigned short int old_vid, old_page; /* Old video mode and page */
float *ver, *fac; /* Pointers to first vertex and first facet */

void create_norm(void)
{
 float a[3], b[3]; /*  ࠢ  ஭ ࠭ */
 float m_c;   /*   ଠ */
 float n_f[3]; /*  ଠ */
 int i, j;
 float x1, y1, z1;  /* न 設 ࠭  */
 float x2, y2, z2;
 float x3, y3, z3;


 for (i=0; i<3*num_f; i=i+3)
 {
	x1=*(ver+ (int)(*( fac+i))*3  );		/*	 3d coordinates of vertexes  */
	y1=*(ver+ (int)(*( fac+i))*3+1);    /*	 of facet number i          */
	z1=*(ver+ (int)(*( fac+i))*3+2);

	x2=*(ver+ (int)(*( fac+i+1))*3  );
	y2=*(ver+ (int)(*( fac+i+1))*3+1);
	z2=*(ver+ (int)(*( fac+i+1))*3+2);

	x3=*(ver+ (int)(*( fac+i+2))*3  );
	y3=*(ver+ (int)(*( fac+i+2))*3+1);
	z3=*(ver+ (int)(*( fac+i+2))*3+2);

	a[0]=x2-x1;
	a[1]=y2-y1;
	a[2]=z2-z1;

	b[0]=x3-x1;
	b[1]=y3-y1;
	b[2]=z3-z1;


	/*  ଠ   ୮ ந ஢ a  b */
	n_f[0]=a[1]*b[2]-a[2]*b[1];
	n_f[1]=-a[0]*b[2]+a[2]*b[0];
	n_f[2]=a[0]*b[1]-a[1]*b[0];

	m_c=lnt(n_f);
	for(j=0; j<3; j++) /*   ⮫쪮   c */
	{
	 n_f[j]/=m_c;/**/
	}


	/*  襬   */
	for(j=0; j<3; j++)
	{
	 *(nrm+i+j)=n_f[j];
	}
 }
}

void qsrt(int *a, int ilo, int ihi )
{
 int t;
 int lo, hi, mid;

 lo=ilo;
 hi=ihi;
 mid=*(a+(hi+lo)/2);
 do
 {
	while(*(a+lo)>mid) lo++;
	while(*(a+hi)<mid) hi--;
	if(lo<hi || lo==hi)
	{
	 t=*(a+lo);					/* 塞  */
	 *(a+lo)=*(a+hi);
	 *(a+hi)=t;

	 t=*(iz+lo);				/* 塞  */
	 *(iz+lo)=*(iz+hi);
	 *(iz+hi)=t;

	 lo++;
	 hi--;
	}
 }
 while((lo<hi) || (lo==hi));
 if(hi>ilo) qsrt(a, ilo, hi);
 if(lo<ihi) qsrt(a, lo, ihi);

}

void read_obj(void)	/* Read the object from file */
{
 int f;
 unsigned long int l;
 f=open(_argv[1], O_RDONLY);
 if(f==-1)
 {
	reset_vid();
	printf("Can`t open file %s", _argv[1]);
	exit(0);
 }
 l=filelength(f);
 p=farmalloc(l);

 if(p==0)
 {
	reset_vid();
	printf("Error: There isn`t enough memory to this programm.");
	getch();
	exit(0);
 }

 read(f, p, l);
 close(f);


}
void cls(void)
{
	unsigned long int i;
	for (i=0;i<64000;i++)
	{
	 *(rb+i)=*(vb+i);
	}
}


void triangle(int x1, int y1, int x2,  int y2, int x3,  int y3, char col)
{
 int i, j, sl;
 long int xa,xb,xc,ya,yb,yc;
 int xs1,xs2;

 if(y2<y1)
 {
	if(y2<y3)
	{
	 sl=y1;/* 塞 ⠬ 設 1  2*/
	 y1=y2;
	 y2=sl;
	 sl=x1;
	 x1=x2;
	 x2=sl;
	}
	else
	{
	 sl=y1;  /* 塞 ⠬ 設 1  3*/
	 y1=y3;
	 y3=sl;
	 sl=x1;
	 x1=x3;
	 x3=sl;
	}
 }
 else
 {
	if(y1>y3)
	{
	 sl=y1; /* 塞 ⠬ 設 1  3*/
	 y1=y3;
	 y3=sl;
	 sl=x1;
	 x1=x3;
	 x3=sl;
	}
 }
						/*冷稬 ⠢訥 設*/
 if(y3<y2)
 {
	 sl=y2;  /* 塞 ⠬ 設 1  3*/
	 y2=y3;
	 y3=sl;
	 sl=x2;
	 x2=x3;
	 x3=sl;
 }

 xa=x1;
 ya=y1;
 xb=x2;
 yb=y2;
 xc=x3;
 yc=y3;

 if(yc!=ya)
 {

	for(i=ya;i<=yc;i++) /* 1 */
	{
		xs1=(xa*(yc-ya)+(xc-xa)*(i-ya))/(yc-ya);
		if(i<yb)
		{
			xs2=(xa*(yb-ya)+(xb-xa)*(i-ya))/(yb-ya);
		}
		else
		{
			if(yb==yc)
			{
			 x2=xb;
			}
			else
			{
				xs2=(xc*(yb-yc)+(xb-xc)*(i-yc))/(yb-yc);
			}
		}
		if(xs2>xs1)
		{
			for(j=xs1;j<xs2;j++)
			{
				if((i>0) && (j>0) && (i<200) && (j<320)) *(vb+i*320+j)=col;
			}
		}
		else
		{
		 for(j=xs2;j<xs1;j++)
			{
				if((i>0) && (j>0) && (i<200) &&(j<320)) *(vb+i*320+j)=col;
			}
		}
	} /* 1 */

 }
 else
 {

	if(xa>xb)
	{
	 if(xa>xc)
	 {
		if(xb>xc)
		{
		 xs1=xc;
		 xs2=xa;
		}
		else
		{
		 xs1=xb;
		 xs2=xa;
		}
	 }
	 else
	 {
		xs1=xc;
		xs2=xb;
	 }
	}
	else	/* xa<xb */
	{
	 if(xa>xc)
	 {
		xs1=xc;
		xs2=xb;
	 }
	 else
	 {
		xs1=xa;
		xs2=xb;
	 }
	}

 }
 for(j=xs2;j<xs1;j++)
	{
	 if((i>0) && (j>0) && (i<200) &&(j<320)) *(vb+i*320+j)=col;
	}
}

void scan_vid(void)
{
 _AH=0xf;
 geninterrupt(16);
 old_vid=_AL;
 old_page=_BH;
}
void set_vid(unsigned short int v)
{
 _AH=0;
 _AL=v;
 geninterrupt(16);
}
void reset_vid(void)
{
 _AH=0;
 _AL=old_vid;
 geninterrupt(16);
 _AH=5;
 _AL=old_page;
 geninterrupt(16);
}

void set_col(char col, char r, char g, char b)
{
outportb(0x3c8,col);
outportb(0x3c9,r);
outportb(0x3c9,g);
outportb(0x3c9,b);
}

void grayscale(void)
{
 unsigned long int i;

 for(i=0;i<256;i++)
 {
	set_col(i, i/4, i/4, i/4);
 }
}

float lnt( float *X )  /* 㭪 頥   X. */
{
 return( sqrt( (*(X+0)*(*(X+0))) + (*(X+1)*(*(X+1))) + (*(X+2)*(*(X+2))) ));
}

void mltp( float *Y, float *Z, float *X) /* 㭪 㬭 ୮ Y  Z */
{                            /*  頥 १  X.       */

	*(X+0)=*(Y+1)*(*(Z+2))-(*(Y+2))*(*(Z+1));
	*(X+1)=*(Y+2)*(*(Z+0))-(*(Y+0))*(*(Z+2));
	*(X+2)=*(Y+0)*(*(Z+1))-(*(Y+1))*(*(Z+0));

}

void axis( float *Z ) /* 㭪 ந  室   */
{                     /* ⥬ न. 										*/
	float A[9];         /* Z - न ࠢ饣 . */
	float Y[3];
	float X[3];
	short i;
	float lx, ly, lz;

	/*   न  Y ࠢ 1.  */
	/*  ⠢ न  ᫮  */
	/* ⮣쭮 X  Y.                   */
	/* (୮ ந ࠢ 0). */


	if(*(Z+2)==0)
	{
	 if(*(Z)==0)
	 {
		*(Y+2)=0;
		*(Y+1)=0;
		*(Y)=1;
	 }
	 else
	 {
		*(Y+2)=0;
		*(Y+1)=1;
		*(Y+0)=-*(Z+1)/(*Z);
	 }
	}
	else
	{
	 *(Y+0)=1;
	 *(Y+1)=1;
	 *(Y+2)=-1*(*Z+*(Z+1))/(*(Z+2));
	}

	/* 騩     */
	/* ୮ ந [X, Y]        */

	mltp( Y, Z, X );

	/*  㦥 ⮭ନ஢ .   */
	/*     ⠬  */
	/* 襬   ⠡. */

	lx=lnt(X);
	ly=lnt(Y);
	lz=lnt(Z);

	for( i=0; i<3; i++)
	{
	 *(X+i)/=lx;
	 *(A+i*3)=*(X+i);
	}
	for( i=0; i<3; i++)
	{
	 *(Y+i)/=ly;
	 *(A+1+i*3)=*(Y+i);
	}

	for( i=0; i<3; i++)
	{
	 *(Z+i)/=lz;
	 *(A+2+i*3)=*(Z+i);
	}
	for( i=0; i<9; i++)
	{
		c[i]=*(A+i);
	}
} /* axis() */

void n_mat( void  )	/* 㭪,    matrix[] */
{                   /*   ८ࠧ,  */
	float t[9]; 			/* ᮮ⢥ 饭    */
	short i, j, k;		/*  Oz  .           */

	/*  c[]   室    .  */
	/* 襬  mc[]   (࠭ᯮ஢).*/
	for(i=0; i<3; i++)
	{
		for(j=0; j<3;j++)
		{
		 mc[j+i*3]=c[i+j*3];
		}
	}
	/* 㦭   ந  c[]*matrix0[]*mc. */

	for(i=0; i<9; i++) t[i]=0;	/* 㫥 -१ */

	for(j=0; j<3; j++)	/* 室 c[]*matrix0[]. */
	{
		for(i=0; i<3; i++)
		{
			for(k=0; k<3; k++)
			{
				t[j*3+i]+=c[j*3+k]*matrix0[k*3+i];
			} /*k*/
		} /*i*/
	}/*j*/

	/* 㥬 t[]  matrix[]. */
	for( i=0; i<9; i++) matrix[i]=t[i];

	for(i=0; i<9; i++) t[i]=0;	/* 㫥 -१ */

	for(j=0; j<3; j++)	/* 室 matrix[]*mc[]. */
	{
		for(i=0; i<3; i++)
		{
			for(k=0; k<3; k++)
			{
				t[j*3+i]+=matrix[j*3+k]*mc[k*3+i];
			} /*k*/
		} /*i*/
	}/*j*/

	/* 㥬 t[]  matrix[]. */
	for( i=0; i<9; i++) matrix[i]=t[i];

} /*n_mat();*/

void draw (void)	/* -  稢 ꥪ */
{
 int  i1, j1;
 float t;

 float x1, y1;
 float x2, y2;
 float x3, y3;
 char col;

 for(i1=0; i1<3*num_f; i1=i1+3)
 {
	*(p_z+i1/3)=(int)((*(ver+(int)(*( fac+i1))*3+2))+(*(ver+ (int)(*( fac+i1+1))*3+2))+(*(ver+ (int)(*( fac+i1+2))*3+2)))/3;
	*(iz+i1/3)=i1/3;
 }
 qsrt(p_z, 0, num_f-1);
 for (j1=0; j1<num_f; j1++)
 {
	i1=*(iz+j1);
	x1=*(ver+ (int)(*( fac+i1*3))*3  );		/*	 3d coordinates of vertexes  */
	y1=*(ver+ (int)(*( fac+i1*3))*3+1);    /*	 of facet number i          */

	x2=*(ver+ (int)(*( fac+i1*3+1))*3  );
	y2=*(ver+ (int)(*( fac+i1*3+1))*3+1);

	x3=*(ver+ (int)(*( fac+i1*3+2))*3  );
	y3=*(ver+ (int)(*( fac+i1*3+2))*3+1);

	/* Can you see this facet? */
	/* ᪨ ।  ᪠ﮭ ந */
	/* ஢-ଠ   (0, 0, 1). */

	 t=*(nrm+i1*3+2);
	 if(t<0)
	 {

		/* Now we need to generate 2d coordinates.*/

			col=(char)(-255*t);
			x1+=160;
			y1=-y1+100;
			x2+=160;
			y2=-y2+100;
			x3+=160;
			y3=-y3+100;
			triangle(x1,y1,x2,y2,x3,y3,col);
		} /* if */
 } /*facets*/

} /*function draw()*/

void prod(float *X, float * A)  /* - ⠥ -  X  A */
{                               /* X - ⮫ न 窨    */
	float Y[3]={0,0,0};           /* A -  ८ࠧ    */
	int i,j;                      /* Y - ⮫  न  */

	for (i=0; i<3; i++)
	{
		for (j=0; j<3; j++)
		{
			Y[i]=Y[i]+*(A+j+i*3)*(*(X+j));
		}	/* j */
	}		/* i */
	for (i=0; i<3; i++)
	{
	 *(X+i)=Y[i];
	}
}			/* function prod() */

void main (int _argc, char **_argv[])
{
	long int i, j;
	float z[3]={-1, 1, -1}; /* ࠢ騩   饭. */

	clrscr();

	randomize();
	z[0]=random(21)-10; /* ࠢ  饭  */
	z[1]=random(21)-10;
	z[2]=random(21)-10;
	off=random(201)-100;	/* 饭  饭 */

	while(kbhit()) getch();
	scan_vid();
	set_vid(19);
	read_obj();



	rb=(char *)MK_FP(0xa000, 0);
	vb=(char *)farmalloc(64000);
	if(vb==0)
	{
		reset_vid();
		printf("Error: There isn`t enough memory to this programm.");
		getch();
		farfree(vb);
		exit(0);
	}
	grayscale();

	num = *(p);
	num_f = *(p+num*3 + 1);
	ver = p+1;
	fac = (ver+3*num+1);
	p_z=farmalloc(2*num_f);	/* । 㡨 ࠭ */
	iz=farmalloc(2*num_f);  /*  ࠭ */
	nrm=farmalloc(4*3*num_f); /* ଠ  ꥪ⠬ ( 3 न  ଠ) */

	for(i=0; i<num; i++)  /* 饭 न 設  稭 off  */
	{
	 *(ver+i*3+0)+=off;
	}

	if(p_z==0 || iz==0 || nrm==0)
	{
	 printf("Error: There isn`t enough memory to this programm.");
	 getch();
	 farfree(p_z);
	 farfree(iz);
	 farfree(nrm);
	 exit(0);
	}
	create_norm();

	axis(&z);		/*   . */
	n_mat();		/*    ८ࠧ. */

	while(!kbhit())
	{
	delay(10);
	create_norm();
	draw();
	while ((inportb(0x3da)&8)!=0); /* Retrace? */
	cls();
	for(i=0;i<64000;i++) *(vb+i)=0;
	for(j=0; j<num; j++)
	{
		prod((ver+j*3), &matrix);
	}
 }
	farfree(vb);
	farfree(p);
	farfree(z);
	farfree(iz);
	farfree(nrm);
	reset_vid();
	exit(0);
}